* same as v8 except using bonmin

* same as v7 except that
* doing full optimization

* same as v6 except that
* adding isothermal stream to heat integration
* original big M by Ignacio does not occur...relaxation of  contribution constraint?
* doing full optimization in next version


* same as mhexcs1v5 except that
* now added Fcp for C3 C5 and C6 into the heat integration
* adding above pinch contribution to heat integration in next version since it will affect the optimization result


* same as mhexcs1v4 except that
* adding the noisothermal streams C3, C5, C6 to the heat integration but one step at a time
* forgot to add expander work...adding that first
* now added Fcp for C3 C5 and C6 into the heat integration
* adding above pinch contribution to heat integration in next version since it will affect the optimization result


* same as mhexcs1v3 except that
* 1) Tin, Tout and FCp are converted from parameters to variables for simple streams

*new stream for heat integration are assigned temperature and heat load data
* C3 stream is from state S1 to S2
* C4 stream is from state S2 to S3
* C5 stream is from state S3 to S4
* C6 stream is from state S5 to S6




* same as mhexcs1v2 except that new streams are introduced into the sets but not used in the code
* basically i use new subsets so that they still work only on the originally specified streams

* same as mhexcs1v1 except that i am including properties of Nitrogen
* defining states for convenience
* S1 - after the pump and entering the MHEX
* S2 - within the MHEX at bubblle point
* S3 - within the MHEX at dew point
* S4 - at exit of MHEX and superheated and entering expander
* S5 - exit of expander and entering MHEX again
* S6 - final exit from MHEX

* a simple version of Duran and Grossmann for minimum utility calculation
* uses smooth approximation for max operators
* at bottom have information for generating composite curves


* global options
$offlisting
$eolcom //
$inlinecom /* */
option limrow = 100 ;
option limcol = 100 ;
option iterlim = 500000 ;
option reslim = 50000 ;
option optcr = 0.0 ;
option solprint = ON ;
option decimals = 8 ;
// end of global options


Scalars
HRAT   Heat recovery approach temperature                        /4/
epsi   epsilon for smooth approximation                          /0.000005/
Tref   "Reference temperature for Enthalpy calculations in K"    /298.15/
PN2Inlet "Pressure of main N2 inlet in bar"                      /6.0/
TN2Inlet "Temperature of main N2 inlet in K"                     /95/
Pmax     "Max pressure to which N2 can be pumped in bar"         /15/
DenLiqN2 "density of liquid N2 in kg/m3"                         /808.607/
PumpEff  "efficiency of pump"                                    /0.75/
ExpdrEff "expander efficiency"                                   /0.7/
MWN2     "molecular weight"                                      /28.0134/
PresS5   "pressure at state S5 in bar"                           /1.01325/
gamma    "Cp/Cv for diatomatic N2"                               /1.4/
Tc     "Critical temperature of N2 in K"                         /126.2/
TrS1
EnthS1
costN2 "cost of liquid nitrogen in cents per litre"              /50/
costElec "cost of electricity in cents per kW hr"                /12/
;

TrS1 = TN2Inlet/Tc ;



Display TrS1 ;


Sets
Str        Total Streams          /H1,H2,H3,C1,C2,C3,C4,C5,C6/

HtStr(Str)    Hot streams of HEX         /H1,H2,H3/
CdStr(Str)    Cold Streams of HEX        /C1,C2,C3,C4,C5,C6/

Simple(Str)   "basic streams"     /H1,H2,H3,C1,C2/
Isoth(Str)    "isothermal streams" /C4/


CC1         "Constants for CP of N2"  /C1,C2,C3,C4,C5,C6,C7/
NonIsoth(Str)
;

NonIsoth(Str) = Str(Str) - Isoth(Str) ;

Display Nonisoth ;


Alias
(Str,Str2,Str3)
;

Parameters
*FCp(Str)    "unit is kW/K"                  /H1 = 3, H2 = 4, H3 = 2, C1 = 3, C2 = 3.5/
*Tin(Str)    "unit is K"                     /H1 = 298, H2 = 265, H3 = 195, C1 = 220, C2 = 255/
*Tout(Str)   "unit is K"                     /H1 = 250, H2 = 180, H3 = 150, C1 = 245, C2 = 280/
Cpconst(CC1) "for Cp = kJ/kmol K, T = K"    /C1 = 29.105, C2 = 8.6149, C3 = 1701.6, C4 = 0.10347, C5 = 909.79/
TSatconst(CC1) "for Tsat, in K, in bar"     /C1 = 46.76907454, C2 = -1084.1, C5 = -8.3144, C6 = 0.044127, C7 = 1/
LtHtconst(CC1) "in MJ/kmol, T in K"         /C1 = 7.4905, C2 = 0.40406, C3 = -0.317, C4 = 0.27343/
;

EnthS1 =   CpConst('C1')*(TN2Inlet - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TN2Inlet) -  1/tanh(CpConst('C3')/Tref))
           - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TN2Inlet) - tanh(CpConst('C5')/Tref))
           -  (LtHtconst('C1')*(1-TrS1)**(LtHtconst('C2')+ LtHtconst('C3')*TrS1 + LtHtconst('C4')*(TrS1**2)))*1000 ;

Display EnthS1 ;


*----------------------------**
** Variables
*----------------------------**
Variables
MxInHt(Str,Str2)
MxOutHt(Str,Str2)
MxOutCd(Str,Str2)
MxInCd(Str,Str2)
HetCntHt(Str)
HetCntCd(Str)
TPch(Str)
HetLd(Str)
HtUtLd
CdUtLd
Omega
FN2   "in kmol/s"
PresS1 "Pressure at state S1"
PumpWork  "in kW"
TempS4 "Temperature at state S4"
TempS5 "Temperture at state S5"
TempS6 "Temperture at state S6"
Tboil  "boiling point at pressure of S1"
EnthS4  "enthalpy at S4 in kJ/kmol"
EnthS3  "enthalpy at S3 in kJ/kmol"
EnthS2  "enthalpy at S2 in kJ/kmol"
EnthS5  "enthalpy at S5 in kJ/kmol"
EnthS6  "enthalpy at S6 in kJ/kmol"
TrS2    "reduced temperature"
Tin(Str)
Tout(Str)
FCp(Str)

dummy1

ExpdrWork

contri(Str,Str2)


;

*--------------------------------*
*     Dummy variables
*--------------------------------*
Variables
Z ;


*-----------------------
* binary variables
*------------------------

Binary variables
YLoc(Str,Str2) "1 indicates that it is above the pinch and contributes while 0 means no contribution"

;





*----------------------------**
** Equations start
*----------------------------**


Equations
EqFF1(Str)
EqFF2(Str)
EqOmega
EqTPch1(Str)
EqTPch2(Str)
EqMxInHt(Str,Str2)
EqMxOutHt(Str,Str2)
EqMxOutCd(Str,Str2)
EqMxInCd(Str,Str2)
EqHetCntHt(Str)
EqHetCntCd(Str)
EqHtUtLd(Str)
EqCdUtLd
EqPumpWork
Eqadiaexpn
EqTboil
EqPhase1
EqEnthS3
EqEnthS4
EqEnthS5
EqEnthS6
EqTrS2
EqEnthS2

EqTinC3
EqToutC3
EqTinC4
EqToutC4
EqTinC5
EqToutC5
EqTinC6
EqToutC6

EqHtLdC3
EqHtLdC4
EqHtLdC5
EqHtLdC6

Eqrefri

EqExpdrWork

Eqlogic1(Str,Str2)
Eqlogic11(Str,Str2)
Eqlogic2(Str,Str2)
Eqlogic3(Str,Str2)
Eqlogic4(Str,Str2)

;


EqFF1(Str)$(HtStr(Str)*Nonisoth(Str))..
  FCp(Str)*(Tin(Str) - Tout(Str)) =E= HetLd(Str) ;

EqFF2(Str)$(CdStr(Str)*Nonisoth(Str))..
  FCP(Str)*(Tout(Str) - Tin(Str)) =E= HetLd(Str) ;

EqOmega..
  Omega =E= SUM(Str$(HtStr(Str)), HetLd(Str)) - SUM(Str$(CdStr(Str)), HetLd(Str)) ;

EqTPch1(Str)$(HtStr(Str))..
  TPch(Str) =E= Tin(Str) ;

EqTPch2(Str)$(CdStr(Str))..
  TPch(Str) =E= Tin(Str) + HRAT ;

EqMxInHt(Str,Str2)$((HtStr(Str)*Nonisoth(Str)))..
  MxInHt(Str,Str2) =E= 0.5*sqrt(Power(Tin(Str)- TPch(Str2),2) + Power(epsi,2)) + 0.5*(Tin(Str)-TPch(Str2)) ;

EqMxOutHt(Str,Str2)$((HtStr(Str)*Nonisoth(Str)))..
  MxOutHt(Str,Str2) =E= 0.5*sqrt(Power(Tout(Str)- TPch(Str2),2) + Power(epsi,2)) + 0.5*(Tout(Str)-TPch(Str2)) ;

EqMxOutCd(Str,Str2)$((CdStr(Str)*Nonisoth(Str)))..
  MxOutCd(Str,Str2) =E= 0.5*sqrt(Power(Tout(Str)- TPch(Str2)+ HRAT,2) + Power(epsi,2)) + 0.5*(Tout(Str)-TPch(Str2)+HRAT) ;

EqMxInCd(Str,Str2)$((CdStr(Str)*Nonisoth(Str)))..
  MxInCd(Str,Str2) =E= 0.5*sqrt(Power(Tin(Str)- TPch(Str2)+ HRAT,2) + Power(epsi,2)) + 0.5*(Tin(Str)-TPch(Str2)+HRAT) ;

EqHetCntHt(Str2)..
        HetCntHt(Str2) =E= SUM(Str$(HtStr(Str)*Nonisoth(Str)), FCp(Str)*(MxInHt(Str,Str2) - MxOutHt(Str,Str2))) ;

* about the isothermal cold stream
Eqlogic1(Str,Str2)$((CdStr(Str)*Isoth(Str)))..
       contri(Str,Str2) - HetLd(Str) =L= 10000*(1-YLoc(Str,Str2)) ;

Eqlogic11(Str,Str2)$((CdStr(Str)*Isoth(Str)))..
       contri(Str,Str2) - HetLd(Str) =G= -10000*(1-YLoc(Str,Str2)) ;

Eqlogic2(Str,Str2)$((CdStr(Str)*Isoth(Str)))..
       contri(Str,Str2) =L= 10000*YLoc(Str,Str2) ;

Eqlogic3(Str,Str2)$((CdStr(Str)*Isoth(Str)))..
       Tin(Str) - TPch(Str2) =G= -500*(1 -YLoc(Str,Str2)) ;

Eqlogic4(Str,Str2)$((CdStr(Str)*Isoth(Str)))..
       Tin(Str) =L=  TPch(Str2) - epsi + 500*YLoc(Str,Str2) ;

EqHetCntCd(Str2)..
        HetCntCd(Str2) =E= SUM(Str$(CdStr(Str)*Nonisoth(Str)), FCP(Str)*(MxOutCd(Str,Str2) - MxInCd(Str,Str2))) + SUM(Str$(CdStr(Str)*Isoth(Str)),contri(Str,Str2)) ;

EqHtUtLd(Str2)..
        HtUtLd =G= HetCntCd(Str2) - HetCntHt(Str2) ;

EqCdUtLd..
        CdUtLd =E= Omega + HtUtLd ;

EqPumpWork..
        PumpWork =E= (PresS1 - PN2Inlet)*FN2*MWN2*100/(PumpEff*DenLiqN2)  ;
* pressure in bar...so multipled by 100 to convert to kPa...kg gets cancelled with m3 in numerator
* final result is kW

Eqadiaexpn..
        (gamma-1)*log(PresS1) + gamma*log(TempS5) =E= (gamma-1)*log(PresS5) + gamma*log(TempS4) ;
* wrote the expresion in log form

EqTboil..
        log(PresS1) =E=  TSatconst('C1') + TSatconst('C2')/Tboil + TSatconst('C5')*log(Tboil) +  TSatconst('C6')*Tboil ;

EqPhase1..
        TempS4 =G= Tboil ;

EqEnthS3..
       EnthS3 =E=   CpConst('C1')*(Tboil - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/Tboil) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/Tboil) - tanh(CpConst('C5')/Tref)) ;

EqEnthS4..
       EnthS4 =E=   CpConst('C1')*(TempS4 - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS4) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS4) - tanh(CpConst('C5')/Tref)) ;

EqEnthS5..
       EnthS5 =E=   CpConst('C1')*(TempS5 - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS5) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS5) - tanh(CpConst('C5')/Tref)) ;

EqEnthS6..
       EnthS6 =E=   CpConst('C1')*(TempS6 - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS6) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS6) - tanh(CpConst('C5')/Tref)) ;

EqExpdrWork..
       ExpdrWork  =E= (EnthS4 - EnthS5)*FN2*ExpdrEff ;



EqTrS2..
       TrS2 =E=  Tboil/Tc ;

EqEnthS2..
       EnthS2 =E=  EnthS3 - (LtHtconst('C1')*(1-TrS2)**(LtHtconst('C2')+ LtHtconst('C3')*TrS2 + LtHtconst('C4')*(TrS2**2)))*1000 ;

* inlet temperature data for C3 stream
EqTinC3..
       Tin('C3') =E=  TN2Inlet ;

* outlet temperature data for C3 stream
EqToutC3..
       Tout('C3') =E=  Tboil ;


* inlet temperature data for C4 stream
EqTinC4..
       Tin('C4') =E=  Tboil ;

* outlet temperature data for C4 stream
EqToutC4..
       Tout('C4') =E=  Tboil ;


* inlet temperature data for C5 stream
EqTinC5..
       Tin('C5') =E=  Tboil ;

* outlet temperature data for C5 stream
EqToutC5..
       Tout('C5') =E=  TempS4 ;


* inlet temperature data for C6 stream
EqTinC6..
       Tin('C6') =E=  TempS5 ;

* outlet temperature data for C6 stream
EqToutC6..
       Tout('C6') =E=  TempS6 ;

EqHtLdC3..
       HetLd('C3') =E= (EnthS2 - EnthS1)*FN2 ;

EqHtLdC4..
       HetLd('C4') =E= (EnthS3 - EnthS2)*FN2 ;

EqHtLdC5..
       HetLd('C5') =E= (EnthS4 - EnthS3)*FN2 ;

EqHtLdC6..
       HetLd('C6') =E= (EnthS6 - EnthS5)*FN2 ;

Eqrefri..
       dummy1 =E= HetLd('C3') + HetLd('C4') + HetLd('C5') + HetLd('C6')  ;



*=====================
*= CONTROL EQUATIONS =
*=====================
EQUATIONS
EqControl
EqControl2
;

SCALARS
perp1   /0.6e-7/
perp2   /1e-6/
;

EqControl..
* FN2 =E= 0.02959005;
  FN2 =E= 0.02959005+perp1;
* FN2 =E= 0.02959005*(1-perp1);

EqControl2..
* PumpWork =E= 0.17132506;
* PumpWork =E= 0.17132506*(1+perp2);
  PumpWork =E= 0.17132506-perp2;
* PresS1  =E= 7.25345316;
* PresS1  =E= 7.25345316*(1+perp2);
* PresS1  =E= 7.25345316*(1-perp2);




*----------------------------------------*
**  Equation for objective function
*----------------------------------------*
Equations
obj ;

obj..
*  Z =E= 1000*HtUtLd + 1000*CdUtLd + FN2*MWN2*1000*costN2/DenLiqN2 + costElec*(Pumpwork - ExpdrWork)/3600 ;
 Z =E= 1000*HtUtLd + 1000*CdUtLd + FN2*MWN2*1000*costN2/(100*DenLiqN2) + costElec*(Pumpwork - ExpdrWork)/(3600*100) ;

*-------------------------
*   bounds
*--------------------------
HetLd.lo(Str) = 0.0 ;
HetLd.up(Str) = 1000.0 ;

Fcp.lo(Str) = 0.0001 ;
Fcp.up(Str) = 1000 ;

FN2.lo = 0.0 ;
FN2.up = 10.0 ;

PresS1.lo  = PN2Inlet ;
PresS1.up  = Pmax ;

PumpWork.lo = 0 ;
PumpWork.up = 10000 ;

TempS4.lo = 75 ;
TempS4.up = 300 ;

* to ensure that expander outlet is not in 2 phase
TempS5.lo = 77.36 ;

TempS5.up = 300 ;

Tboil.lo = 50 ;
Tboil.up = 300 ;

TempS6.lo = 77.36 ;
TempS6.up = 300 ;

TrS2.lo = 0.1 ;
TrS2.up = 1.1 ;

EnthS2.lo = -50000 ;
EnthS2.up =  0 ;

EnthS3.lo = -50000 ;
EnthS3.up =  0 ;

EnthS4.lo = -50000 ;
EnthS4.up =  0 ;

EnthS5.lo = -50000 ;
EnthS5.up =  0 ;

EnthS6.lo = -50000 ;
EnthS6.up =  0 ;


contri.lo(Str,Str2) = 0.0 ;
contri.up(Str,Str2) = 10000.0 ;


CdUtLd.lo = -0.0001 ;
HtUtLd.lo = -0.0001 ;



*------------------------*
*      Fixed
*------------------------*

* fixing the Tin, Tout and FCp for simple streams

* unit is kW/K
FCp.fx('H1') = 3 ;
FCp.fx('H2') = 4 ;
FCp.fx('H3') = 2 ;
FCp.fx('C1') = 3 ;
FCp.fx('C2') = 3.5 ;

* unit is K
Tin.fx('H1') = 298 ;
Tin.fx('H2') = 265 ;
Tin.fx('H3') = 195 ;
Tin.fx('C1') = 220 ;
Tin.fx('C2') = 255 ;

* unit is K
Tout.fx('H1') = 250 ;
Tout.fx('H2') = 180 ;
Tout.fx('H3') = 150 ;
Tout.fx('C1') = 245 ;
Tout.fx('C2') = 280 ;


* temporary fixing variables
*FN2.l    = 0.04 ;
*PresS1.l = 11 ;
*TempS4.l = 180 ;
*TempS6.l = 250 ;

* optimal initial values
FN2.l    = 0.02959005 ;
PresS1.l = 7.25345316 ;
TempS4.l = 265.7347 ;
TempS6.l = 293.9971 ;

*------------------------*
*      Initial Point
*------------------------*
HtUtLd.l = 1000*0;
*Tboil.l = 105 ;
Tboil.l = 98.999995 ;

* logic
YLoc.l('C4','H1') = 0 ;
YLoc.l('C4','H2') = 0 ;
YLoc.l('C4','H3') = 0 ;
YLoc.l('C4','C1') = 0 ;
YLoc.l('C4','C2') = 0 ;
YLoc.l('C4','C3') = 0 ;
YLoc.l('C4','C4') = 0 ;
YLoc.l('C4','C5') = 0 ;
YLoc.l('C4','C6') = 0 ;




PumpWork.l = (PresS1.l - PN2Inlet)*FN2.l*MWN2*100/(PumpEff*DenLiqN2)  ;

TempS5.l = TempS4.l*(PresS5/PresS1.l)**((gamma-1)/gamma)   ;

EnthS3.l =   CpConst('C1')*(Tboil.l - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/Tboil.l) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/Tboil.l) - tanh(CpConst('C5')/Tref)) ;

EnthS4.l =   CpConst('C1')*(TempS4.l - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS4.l) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS4.l) - tanh(CpConst('C5')/Tref)) ;


EnthS5.l =   CpConst('C1')*(TempS5.l - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS5.l) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS5.l) - tanh(CpConst('C5')/Tref)) ;

*EnthS5.l = -4271.0317 ;

EnthS6.l =   CpConst('C1')*(TempS6.l - Tref) + CpConst('C2')*CpConst('C3')*(1/tanh(CpConst('C3')/TempS6.l) -  1/tanh(CpConst('C3')/Tref))
                    - CpConst('C4')*CpConst('C5')*(tanh(CpConst('C5')/TempS6.l) - tanh(CpConst('C5')/Tref)) ;

ExpdrWork.l  = (EnthS5.l - EnthS4.l)*FN2.l*ExpdrEff ;

TrS2.l =  Tboil.l/Tc ;

EnthS2.l =  EnthS3.l - (LtHtconst('C1')*(1-TrS2.l)**(LtHtconst('C2')+ LtHtconst('C3')*TrS2.l + LtHtconst('C4')*(TrS2.l**2)))*1000 ;

Tin.l('C3') =  TN2Inlet ;

Tout.l('C3') =  Tboil.l ;

Tin.l('C4') =  Tboil.l ;

Tout.l('C4') =  Tboil.l ;

Tin.l('C5') =  Tboil.l ;

Tout.l('C5') =  TempS4.l ;

Tin.l('C6') =  TempS5.l ;

Tout.l('C6') =  TempS6.l ;

HetLd.l('C3') = (EnthS2.l - EnthS1)*FN2.l ;

HetLd.l('C4') = (EnthS3.l - EnthS2.l)*FN2.l ;

HetLd.l('C5') = (EnthS4.l - EnthS3.l)*FN2.l ;

HetLd.l('C6') = (EnthS6.l - EnthS5.l)*FN2.l ;

dummy1.l = HetLd.l('C3') + HetLd.l('C4') + HetLd.l('C5') + HetLd.l('C6')  ;

HetLd.l(Str)$(HtStr(Str)*Nonisoth(Str)) =   FCp.l(Str)*(Tin.l(Str) - Tout.l(Str)) ;
HetLd.l(Str)$(CdStr(Str)*Nonisoth(Str)) =   FCp.l(Str)*(Tout.l(Str) - Tin.l(Str)) ;

FCp.l(Str)$(HtStr(Str)*(NOT Simple(Str))*Nonisoth(Str)) =   HetLd.l(Str)/(Tin.l(Str) - Tout.l(Str)) ;
FCp.l(Str)$(CdStr(Str)*(NOT Simple(Str))*Nonisoth(Str)) =   HetLd.l(Str)/(Tout.l(Str) - Tin.l(Str)) ;

Omega.l = SUM(Str$(HtStr(Str)*Nonisoth(Str)), HetLd.l(Str)) - SUM(Str$(CdStr(Str)*Nonisoth(Str)), HetLd.l(Str)) ;

TPch.l(Str)$(HtStr(Str)*Nonisoth(Str)) = Tin.l(Str) ;
TPch.l(Str)$(CdStr(Str)*Nonisoth(Str)) = Tin.l(Str) + HRAT ;

MxInHt.l(Str,Str2)$((HtStr(Str)*Nonisoth(Str)) AND Nonisoth(Str2)) = 0.5*sqrt(Power(Tin.l(Str)- TPch.l(Str2),2) + Power(epsi,2)) + 0.5*(Tin.l(Str)-TPch.l(Str2)) ;
MxOutHt.l(Str,Str2)$((HtStr(Str)*Nonisoth(Str)) AND Nonisoth(Str2)) = 0.5*sqrt(Power(Tout.l(Str)- TPch.l(Str2),2) + Power(epsi,2)) + 0.5*(Tout.l(Str)-TPch.l(Str2)) ;
MxOutCd.l(Str,Str2)$((CdStr(Str)*Nonisoth(Str)) AND Nonisoth(Str2)) = 0.5*sqrt(Power(Tout.l(Str)- TPch.l(Str2)+ HRAT,2) + Power(epsi,2)) + 0.5*(Tout.l(Str)-TPch.l(Str2)+HRAT) ;
MxInCd.l(Str,Str2)$((CdStr(Str)*Nonisoth(Str)) AND Nonisoth(Str2)) = 0.5*sqrt(Power(Tin.l(Str)- TPch.l(Str2)+ HRAT,2) + Power(epsi,2)) + 0.5*(Tin.l(Str)-TPch.l(Str2)+HRAT) ;

HetCntHt.l(Str2)$Nonisoth(Str2) = SUM(Str$(HtStr(Str)*Nonisoth(Str)), FCp.l(Str)*(MxInHt.l(Str,Str2) - MxOutHt.l(Str,Str2))) ;
HetCntCd.l(Str2)$Nonisoth(Str2) = SUM(Str$(CdStr(Str)*Nonisoth(Str)), FCP.l(Str)*(MxOutCd.l(Str,Str2) - MxInCd.l(Str,Str2))) ;

CdUtLd.l = Omega.l + HtUtLd.l ;

Z.l = 10*HtUtLd.l + 120*CdUtLd.l ;







Model Ravi /All/ ;

Ravi.holdfixed = 1 ;

option minlp = sbb ;



Solve Ravi using MINLP minimizing Z ;

Display FN2.l, PumpWork.l ,PresS1.l, TempS4.l, TempS5.l, TempS6.l, Tboil.l,  Z.l , YLoc.l, contri.l, FCp.l, Tin.l, Tout.l;