$TITLE Ex1
$OFFSYMXREF
$OFFSYMLIST

OPTION SOLPRINT = ON ;

SETS
    m    flows   / 1*4 /
    i(m) subset  / 2*4 /
;

PARAMETERS
    OCT(m)  the values of the octane numbers
        /   1   99  ,
            2   105 ,
            3   95  ,
            4   99      / 
    BENZ(m) the values of benzene content in the flows
        /   1   0   ,
            2   0   ,
            3   0   ,
            4   0.02    / 
    P(m)    the prices of the different flows in dollar per kg
        /   1   0.1 ,
            2   0.2 ,
            3   0.12,
            4   0.185   / 

VARIABLES 
    COST
    X(m)
;

POSITIVE VARIABLES
    X(m)    flow rate of stream m
;

EQUATIONS 
    E1,E2,I1,I2,I3
;

*E1..COST =E= SUM(m, P(m)*X(m));
E1..COST =E= P('1')*(1+X('1'))*X('1') + SUM(m$(ORD(m) NE 1), P(m)*X(m)); 
*E1..COST =E= P('1')*(1+X('1'))*X('1') + SUM(i, P(i)*X(i)); 
E2..1 =E= SUM(m, X(m));
I1..98 =L= SUM(m, X(m)*OCT(m));    
I2..0.01 =G= SUM(m, X(m)*BENZ(m));
I3..0.4 =G= X('1');

MODEL JUPITER/ALL/;
SOLVE JUPITER USING NLP MINIMIZING COST;